/*  FTCS lab 3 */
/* disk control deamon */
/* listens on a port IN_PORT, and then writes out to the client  */
/* when it recieves its get command                              */

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <fcntl.h>
#include <sys/un.h>
#include <stdlib.h>
#include <unistd.h>
#include <netdb.h>
#include <netinet/in.h>

#define IN_PORT 30000 /* port the deamon listens to */
#define OUT_PORT 30001 /* port that the client is expecting the data to be returned to */



struct sockaddr_in pair;

int outSocketFD,temp;
int inSocketFD;
int localFD;
char* fileNameString;

char tempCharacter;


int f;

int main(int argc, char ** argv){
	int sockLength;

	fileNameString = "/tmp/ftcs.spongebobsquarepants";


	localFD = open(fileNameString,O_RDWR|O_CREAT|O_TRUNC, 0x1B6);

	if(localFD < 0 ){
		printf("error opening %s \n Quitting... \n ",fileNameString);
	}

	inSocketFD = socket(PF_INET, SOCK_STREAM, 0);

	outSocketFD = socket(PF_INET, SOCK_STREAM, 0);

	/* need to add bit about pot nubers for pair */


	pair.sin_family = PF_INET;
	pair.sin_addr.s_addr = INADDR_ANY;
	pair.sin_port = htons(IN_PORT);

	sockLength = sizeof(pair);

	bind(inSocketFD, (struct sockaddr *) &pair, sockLength );




	f = fork();
	if(f == 0){

	     while(1){
		listen(inSocketFD,2);

		printf("L: listening for connections \n");

		temp = accept(inSocketFD, (struct sockaddr *) &pair, &(sockLength) );

		printf("L: connected \n");

		lseek(localFD,0,SEEK_SET);

		read(temp,&tempCharacter,1);

		while(tempCharacter != EOF){

			printf("L: recieved %c \n",tempCharacter );

			write(localFD, &tempCharacter, 1);

			if( !read(temp, &tempCharacter,1) ){
				tempCharacter = EOF;
			}
		}
	     }
	}/* end of fork */


	/*setup pair for the sending port */

	pair.sin_port = (htons(OUT_PORT));
	bind(outSocketFD, (struct sockaddr *) &pair, sockLength );
	


	while(1){
		listen(outSocketFD,1);

		printf("W: listening for connection \n");
		temp = accept(outSocketFD, (struct sockaddr *) &pair, &(sockLength) );

		printf("W: connected \n");

		tempCharacter = 'b';

		lseek(localFD,0,SEEK_SET);

		while(tempCharacter != EOF){

			if( !read(localFD, &tempCharacter,1) ) tempCharacter = EOF;
			write(temp,&tempCharacter,1);
			printf("W: wrote %c \n",tempCharacter);

		}
	}


	return 5;
}/*end main */


